//
// Copyright (c) 1996 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved

// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "fpcntclt.h"
#include "MainDlg.h"
#include "cdibbtn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog


CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	m_radioStyleSelection = 0;
	m_bResetEnabled = FALSE;
	m_szCustomImageFile = _T("custom.gif");
	m_nResetValue = 0;
	m_iFixedDigitsValue = 5;
	m_bFixedDigitsEnabled = FALSE;
	//}}AFX_DATA_INIT
	m_idPalette = IDB_BITMAP0;		// All bitmaps use the same palette
	m_image0.SetParent(this, 0);
	m_image1.SetParent(this, 1);
	m_image2.SetParent(this, 2);
	m_image3.SetParent(this, 3);
	m_image4.SetParent(this, 4);
}


CMainDlg::~CMainDlg()
{
}




void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_IMAGE4, m_image4);
	DDX_Control(pDX, IDC_IMAGE3, m_image3);
	DDX_Control(pDX, IDC_IMAGE2, m_image2);
	DDX_Control(pDX, IDC_IMAGE1, m_image1);
	DDX_Control(pDX, IDC_IMAGE0, m_image0);
	DDX_Radio(pDX, IDC_STYLE_RADIO_0, m_radioStyleSelection);	
	DDX_Text(pDX, IDC_CUSTOM_IMAGE_EDIT, m_szCustomImageFile);
	DDX_Text(pDX, IDC_RESET_EDIT, m_nResetValue);
	DDX_Text(pDX, IDC_FIXED_DIGITS_EDIT, m_iFixedDigitsValue);		
	DDX_Check(pDX, IDC_RESET_CHECK, m_bResetEnabled);
	DDX_Check(pDX, IDC_FIXED_DIGITS_CHECK, m_bFixedDigitsEnabled);
	DDV_MinMaxLong(pDX, m_nResetValue, 0, 9999999);
	DDV_MinMaxInt(pDX, m_iFixedDigitsValue, 1, 10);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_CREATE()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_BN_CLICKED(IDC_RESET_CHECK, OnResetCheck)
	ON_BN_CLICKED(IDC_STYLE_RADIO_0, OnStyleRadio)
	ON_BN_CLICKED(IDC_STYLE_RADIO_5, OnStyleRadio5)
	ON_BN_CLICKED(IDC_STYLE_RADIO_1, OnStyleRadio)
	ON_BN_CLICKED(IDC_STYLE_RADIO_2, OnStyleRadio)
	ON_BN_CLICKED(IDC_STYLE_RADIO_3, OnStyleRadio)
	ON_BN_CLICKED(IDC_STYLE_RADIO_4, OnStyleRadio)
	ON_BN_CLICKED(IDC_FIXED_DIGITS_CHECK, OnFixedDigitsCheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




//////////////////////////////////////////////////////////////////////////
// CMainDlg initialization and finalization methods


void CMainDlg::DictionaryToDialog(CWebBotDict &dict)
{	
	const char *szTemp;	

	if (szTemp = dict.GetValue("B-Reset"))
	{
		// Enable if reset is TRUE (or first letter is T)
		m_bResetEnabled = (*szTemp == 'T');
	}
	
	if (szTemp = dict.GetValue("I-ResetValue"))
	{
		m_nResetValue = atol(szTemp);
	}	
	
	if (szTemp = dict.GetValue("I-Image"))		
		m_radioStyleSelection = atol(szTemp);	

		
	if ((szTemp = dict.GetValue("U-Custom")) && 
		(szTemp) && 
		(*szTemp != '\0'))
	{
		m_radioStyleSelection = CMainDlg::IMAGES-1;		
		m_szCustomImageFile = szTemp;
	}
	if (szTemp = dict.GetValue("I-Digits"))
	{
		m_iFixedDigitsValue = atol(szTemp);
		if (m_iFixedDigitsValue == 0)
		{
			m_bFixedDigitsEnabled = FALSE;
			m_iFixedDigitsValue = 5;
		}
		else
			m_bFixedDigitsEnabled = TRUE;
	}	
}




void CMainDlg::DialogToDictionary(CWebBotDict &dict)
{
	// If something is disabled, we keep the key available, but set
	// the contents to something we are expecting means disabled
	// (0 for fixed digits, blank for custom image)
	// This is so that a bot created with this custom DLL can still
	// be loaded without the custom DLL into the generic editor
	// if need be.  To be completely correct, the HELP, DESCR, and
	// all the MIN and MAX attributes would also be set here, which
	// would make it so that if this bot is inserted with this DLL
	// and then later edited on a platform which does not support
	// custom DLL bots, it could be fully functional in the generic
	// editor.  I feel that this is not a common case, and am 
	// giving enough support that it will still be editable in the
	// generic editor, but without help or ranges.  Also, a bot
	// originally created with the BTL file will work complely fine
	// if then edited with this DLL, then taken back and edited on
	// a platform that doesn't support custom DLLs.
	//
	// e.g:  created with DLL, then edited without DLL: sort of works
	//       created with BTL, then edited with DLL -> edited without: works


	char buffer[30];		
	dict.SetValue("I-ResetValue", ltoa(m_nResetValue, buffer, 10));	
	dict.SetValue("B-Reset", (m_bResetEnabled ? "TRUE" : "FALSE"));

	if (m_bFixedDigitsEnabled)
	{
		char buffer[30];
		dict.SetValue("I-Digits", ltoa(m_iFixedDigitsValue, buffer, 10));
	}
	else
		dict.SetValue("I-Digits", "0");
		
	// Always set the image key, set the custom key if it's the last one
	dict.SetValue("I-Image", ltoa(m_radioStyleSelection, buffer, 10));

	// If they chose an image, clear the custom key, otherwise set it
	if (m_radioStyleSelection != CMainDlg::IMAGES-1)
		dict.SetValue("U-Custom", "");
	else	
		dict.SetValue("U-Custom", m_szCustomImageFile);		
}





///////////////////////////////////////////////////////////////////////////
// CMainDlg image handling and layout methods


void CMainDlg::LoadBitmaps()
{
	m_image0.SetDIB(IDB_BITMAP0);
	m_image1.SetDIB(IDB_BITMAP1);
	m_image2.SetDIB(IDB_BITMAP2);
	m_image3.SetDIB(IDB_BITMAP3);
	m_image4.SetDIB(IDB_BITMAP4);

	m_image0.SizeToContent();
	m_image1.SizeToContent();
	m_image2.SizeToContent();
	m_image3.SizeToContent();
	m_image4.SizeToContent();
}


void CMainDlg::CenterVertical(CWnd *object, const CRect &reference)
{
	CRect rect;
	object->GetWindowRect(rect);
	ScreenToClient(rect);

	// Height offset by the difference between the two centers
	rect.OffsetRect(0, (reference.bottom + reference.top)/2 -
					   (rect.bottom + rect.top)/2);
	object->MoveWindow(rect);
}
	


void CMainDlg::DoLayout()
{
	// Layout all of the images and associated radio buttons.
	// Set the size of the "counter style" group box, the dialog itself,
	// and the position of everything below the group box, which is
	// the reset stuff, the set digits stuff, and the ok and cancel buttons.

	const int imageVerticalBorder = 8;
	
	int i;


	//////////////////////////////////////////////////////////////
	// The images and radio buttons

	// First, get all the sizing information we want.

	CWnd *radio[IMAGES];

	radio[0] = GetDlgItem(IDC_STYLE_RADIO_0);
	radio[1] = GetDlgItem(IDC_STYLE_RADIO_1);
	radio[2] = GetDlgItem(IDC_STYLE_RADIO_2);
	radio[3] = GetDlgItem(IDC_STYLE_RADIO_3);
	radio[4] = GetDlgItem(IDC_STYLE_RADIO_4);
	radio[5] = GetDlgItem(IDC_STYLE_RADIO_5);
	
	CWnd *image[IMAGES];
	
	image[0] = GetDlgItem(IDC_IMAGE0);
	image[1] = GetDlgItem(IDC_IMAGE1);
	image[2] = GetDlgItem(IDC_IMAGE2);
	image[3] = GetDlgItem(IDC_IMAGE3);
	image[4] = GetDlgItem(IDC_IMAGE4);
	image[5] = GetDlgItem(IDC_CUSTOM_IMAGE_EDIT);

	CRect imageRect[IMAGES];

	for (i=0; i<IMAGES; i++)
	{
		image[i]->GetWindowRect(imageRect[i]);
		ScreenToClient(imageRect[i]);
	}

	// Lay out the images vertically so that the first one remains at the
	// same location, and the others are spaced out below.

	int y=imageRect[0].top;

	for (i=0; i<IMAGES; i++)
	{
		imageRect[i].OffsetRect(0, y - imageRect[i].top);
		y = imageRect[i].bottom + imageVerticalBorder;
	}

	// Move the images to the rectangle calculated
	for (i=0; i<IMAGES; i++)
		image[i]->MoveWindow(imageRect[i]);

	// Set the associated radio button to be at the center of the image
	for (i=0; i<IMAGES; i++)	
		CenterVertical(radio[i], imageRect[i]);
	

	/////////////////////////////////////////////////////////
	// The counter style group box

	// Set the "counter style" group box dimensions so that it has the
	// same border around all of the images.  The width from the group box
	// to an image will be taken from the border of the left side of the
	// radio button to the group box.  This border size will be replicated
	// all around the group box.

	CRect imageGroupRect, radioRect;
	radio[0]->GetWindowRect(radioRect);
	ScreenToClient(radioRect);
	GetDlgItem(IDC_IMAGE_GROUP)->GetWindowRect(imageGroupRect);
	ScreenToClient(imageGroupRect);
	int border = radioRect.left - imageGroupRect.left;

	int maxRight = 0;
	// Find the image which stretches to the rightmost area of the dialog
	for (i=0; i<IMAGES; i++)
	{
		if (imageRect[i].right > maxRight)
			maxRight = imageRect[i].right;
	}

	imageGroupRect.right = maxRight + border;
	imageGroupRect.bottom = imageRect[IMAGES-1].bottom + border;

	// Move it
	GetDlgItem(IDC_IMAGE_GROUP)->MoveWindow(imageGroupRect);

	// This defines the border to be used all around the dialog box
	int dialogBorder = imageGroupRect.left;

	/////////////////////////////////////////////////////////
	// The reset edit and checkbox

	// Move the reset checkbox and reset edit box to the correct
	// location under the group box.  Use the same border as the
	// one all around the dialog box for the edit box, and center
	// the check box to it.

	CRect resetEditRect;
	GetDlgItem(IDC_RESET_EDIT)->GetWindowRect(resetEditRect);
	ScreenToClient(resetEditRect);	

	resetEditRect.OffsetRect(0, imageGroupRect.bottom + dialogBorder
							- resetEditRect.top);
	// Move it
	GetDlgItem(IDC_RESET_EDIT)->MoveWindow(resetEditRect);
	// Center the text on the check box:
	CenterVertical(GetDlgItem(IDC_RESET_CHECK), resetEditRect);

	/////////////////////////////////////////////////////////
	// The fixed digits edit and check box

	// Move the fixed digits checkbox and edit box to the correct
	// location under the reset check and edit boxes, and center
	// the check box to it.

	CRect fixedDigitsRect;
	GetDlgItem(IDC_FIXED_DIGITS_EDIT)->GetWindowRect(fixedDigitsRect);
	ScreenToClient(fixedDigitsRect);
	fixedDigitsRect.OffsetRect(0, resetEditRect.bottom + dialogBorder/2
							- fixedDigitsRect.top);
	// Move it
	GetDlgItem(IDC_FIXED_DIGITS_EDIT)->MoveWindow(fixedDigitsRect);
	// Center the text on the check box:
	CenterVertical(GetDlgItem(IDC_FIXED_DIGITS_CHECK), fixedDigitsRect);

	/////////////////////////////////////////////////////////
	// The dialog box

	// Whew, Almost done laying out...
	// Figure out the width of the dialog box by taking the
	// max of the right edge group box we just resized, and
	// the rightmost other component in the dialog box, which is 
	// the fixed digits edit box.  And add the same amount
	// of border as we are giving to the left edge of these group boxes
	int dialogWidth = (fixedDigitsRect.right > imageGroupRect.right ?
						fixedDigitsRect.right : imageGroupRect.right);
	// Add the border	
	dialogWidth += dialogBorder;

	// Now that we know the correct width for the dialog, move the 
	// Ok and Cancel buttons so that they are correct.  We want them
	// it to be laid out like <space>[OK]<k*space>[CANCEL]<space>
	// this means space is
	// (dialogWidth - OkWidth - CancelWidth)/(2+k)
	const double k = 0.3;
	// I'll use a value of 0. for k, which tends to look nice.
	
	CWnd *okButton = GetDlgItem(IDOK);
	CWnd *cancelButton = GetDlgItem(IDCANCEL);
	CRect okRect, cancelRect;
	okButton->GetWindowRect(okRect);
	cancelButton->GetWindowRect(cancelRect);
	ScreenToClient(okRect);
	ScreenToClient(cancelRect);


	double space = (dialogWidth - okRect.Width() - cancelRect.Width())/(2+k);
	// Also figure out what height these buttons should be.  We'll set
	// them to the bottom edge of the reset edit box plus the same
	// dialog border being used elsewhere
	int buttonTop = fixedDigitsRect.bottom + dialogBorder;
	okRect.OffsetRect((int)space - okRect.left, 
					  buttonTop - okRect.top);
	cancelRect.OffsetRect((int)((k+1)*space) + okRect.Width() - cancelRect.left,
						  buttonTop - cancelRect.top);

	okButton->MoveWindow(okRect);
	cancelButton->MoveWindow(cancelRect);	

	// Last but not least, set the size of the dialog box itself
	// Already know dialogWidth.  dialogHeight is the bottom of the
	// ok button, plus the same border of the left side of the counter
	// style group box, like the other borders.
	int dialogHeight = okRect.bottom + dialogBorder;
	
	// need to add in extra room for window decorations
	CRect dialogRect, dlgClientArea;
	GetWindowRect(dialogRect);
	GetClientRect(&dlgClientArea);
	dialogWidth += (dialogRect.Width() - dlgClientArea.Width());
	dialogHeight += (dialogRect.Height() - dlgClientArea.Height());
	// Make the move
	MoveWindow(dialogRect.left,dialogRect.top, dialogWidth,dialogHeight);
}

///////////////////////////////////////////////////////////////////////////
// Palette Handling

int CMainDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(m_idPalette != 0 && !InitializePalette())
		return -1;
			
	return 0;
}



BOOL CMainDlg::InitializePalette()
{
	// m_idPalette is set in the constructor	
	// force initialization of palette object
	m_palette.m_hObject = NULL;

	CClientDC dc(this);
	if (dc.GetDeviceCaps(RASTERCAPS) & RC_PALETTE)
	{	
		// load up one of the sample DIB resources that has the right palette;
		// can't do LoadBitmap() because the palette info gets
		// thrown away; so load it as a generic resource and the entire
		// DIB (minus the BITMAPFILEHEADER struct) will be in the memory 
		// block returned from LoadResource

		if(m_idPalette != 0)
		{
			HDIB hDib = LoadDIBResource(m_idPalette);
			BOOL brc = CreateDIBPalette(hDib,&m_palette);
			CDIBBtn::pGlobalPalette = &m_palette;
			::GlobalFree((HGLOBAL)hDib);			
		}

		// don't need to delete palette on exit; 
		// the CPalette destructor will get called	
	}

	return TRUE;
}
BOOL CMainDlg::OnQueryNewPalette()
{
	DoRealize(this);
	return CDialog::OnQueryNewPalette();
}

void CMainDlg::OnPaletteChanged(CWnd* pFocusWnd)
{
	CDialog::OnPaletteChanged(pFocusWnd);
	DoRealize(pFocusWnd);
}

void CMainDlg::DoRealize(CWnd *pFocusWnd)
{
	CClientDC dc(this);
	if (dc.GetDeviceCaps(RASTERCAPS) & RC_PALETTE
		&& m_palette.m_hObject != NULL)
	{
		CPalette *pOldPal = dc.SelectPalette(&m_palette, (pFocusWnd != this));
		if (pOldPal != NULL)
		{
			int iCount = dc.RealizePalette();
			Invalidate(TRUE);
			dc.SelectPalette(pOldPal, TRUE);
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();	

	LoadBitmaps();
	DoLayout();

	UpdateData(FALSE);

	// Enable or disable the edit boxes:
	GetDlgItem(IDC_CUSTOM_IMAGE_EDIT)->EnableWindow(
			m_radioStyleSelection == CMainDlg::IMAGES-1);	

	GetDlgItem(IDC_RESET_EDIT)->EnableWindow(m_bResetEnabled);
	GetDlgItem(IDC_FIXED_DIGITS_EDIT)->EnableWindow(m_bFixedDigitsEnabled);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



// This callback is called whenever one of the images was clicked
void CMainDlg::DIBClicked(long data)
{
	if (UpdateData())
	{
		m_radioStyleSelection = data;
		UpdateData(FALSE);	
	}

	switch (data)
	{
	case 0: GetDlgItem(IDC_STYLE_RADIO_0)->SetFocus(); break;
	case 1: GetDlgItem(IDC_STYLE_RADIO_1)->SetFocus(); break;
	case 2: GetDlgItem(IDC_STYLE_RADIO_2)->SetFocus(); break;
	case 3: GetDlgItem(IDC_STYLE_RADIO_3)->SetFocus(); break;	
	case 4: GetDlgItem(IDC_STYLE_RADIO_4)->SetFocus(); break;	
	}

	// Since one of the images was clicked, disable the custom edit
	GetDlgItem(IDC_CUSTOM_IMAGE_EDIT)->EnableWindow(FALSE);
}


void CMainDlg::OnResetCheck() 
{
	if (UpdateData())
		GetDlgItem(IDC_RESET_EDIT)->EnableWindow(m_bResetEnabled);
}

// This callback is called whenever the custom image radio button is clicked
void CMainDlg::OnStyleRadio5() 
{
	// Enable the custom edit
	if (UpdateData())
	{
		m_radioStyleSelection = IMAGES-1;		// Set to the last radio btn
		GetDlgItem(IDC_CUSTOM_IMAGE_EDIT)->EnableWindow(TRUE);	
		UpdateData(FALSE);	
	}
}

// This callback is called whenever one of the other image radio buttons
// is clicked.
void CMainDlg::OnStyleRadio() 
{
	// Disable the custom edit
	if (UpdateData())
	{
		GetDlgItem(IDC_CUSTOM_IMAGE_EDIT)->EnableWindow(FALSE);
		UpdateData(FALSE);	
	}	
}

void CMainDlg::OnOK() 
{
	// Only exit if either the "use only these options" checkbox is 
	// checked, or if one of the radio buttons is selected
	if (UpdateData())
	{
		if (m_radioStyleSelection == -1)
			AfxMessageBox(IDE_SELECT_AN_IMAGE);
		else if (m_radioStyleSelection == IMAGES-1 && 
				m_szCustomImageFile.IsEmpty())
				AfxMessageBox(IDE_NONEMPTY_CUSTOM_IMAGE);
		else
			CDialog::OnOK();
	}
}


void CMainDlg::OnFixedDigitsCheck() 
{
	if (UpdateData())
		GetDlgItem(IDC_FIXED_DIGITS_EDIT)->EnableWindow(m_bFixedDigitsEnabled);	
}
