//
// Copyright (c) 1996 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved

// MainDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

#ifndef __MAINDLG_H__
#define __MAINDLG_H__

#include "clickableDib.h"
#include "../../webbot.h"

class CMainDlg : public CDialog
{
// Construction
public:
	CMainDlg(CWnd* pParent = NULL);   // standard constructor
	~CMainDlg();

	void DialogToDictionary(CWebBotDict &dict);
	void DictionaryToDialog(CWebBotDict &dict);


	void DIBClicked(long data);
	enum {IMAGES = 6};


// Dialog Data
	//{{AFX_DATA(CMainDlg)
	enum { IDD = IDD_MAIN_DIALOG };
	CClickableDIB	m_image4;
	CClickableDIB	m_image3;
	CClickableDIB	m_image2;
	CClickableDIB	m_image1;
	CClickableDIB	m_image0;
	int		m_radioStyleSelection;
	BOOL	m_bResetEnabled;
	CString	m_szCustomImageFile;
	long	m_nResetValue;
	int		m_iFixedDigitsValue;
	BOOL	m_bFixedDigitsEnabled;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMainDlg)
	virtual BOOL OnInitDialog();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnResetCheck();
	afx_msg void OnStyleRadio();
	virtual void OnOK();
	afx_msg void OnStyleRadio5();
	afx_msg void OnFixedDigitsCheck();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:	

	UINT m_idPalette;
	CPalette m_palette;
	
	void SetBitmap(int iStaticID, CBitmap &bitmap);
	void LoadBitmaps();
	void CenterVertical(CWnd *object, const CRect &reference);

	// Palette Handling
	BOOL InitializePalette();
	void DoRealize(CWnd *pFocusWnd);


	void DoLayout();


};

#endif
