//
// Copyright (c) 1996 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved

// CNumberImage
//
// Handles concatenation of the numerals to create an image which 
// is a number
//
// 

#include "fpcount.h"
#include "gd.h"

class CNumberImage
{
public:
    CNumberImage();
    ~CNumberImage();

    // Creates a picture which is the number "number" made from
    // the gif image stored at the file pointed to by the
    // numeralTemplate, which must be a GIF where every one-tenth
    // of the width of the GIF contains the picture of a number,
    // starting at 0 and counting to 9
    BOOL CreateImage(istream &numeralTemplate, long number, 
                     BOOL bUseFixedNumDigits = FALSE,
                     int nFixedDigits = 5);

    gdImagePtr GetImage();
    void OutputImageAsGif(FILE *out);

private:
    void CopyNumber(int from, int to);

    gdImagePtr m_numberImage;
    gdImagePtr m_numberTemplate;
    int digitWidth;
    int digitHeight;

};


