//
// Copyright (c) 1996 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved


#include "stdafx.h"
#include "pwssrv.h"
#include "winreg.h"
#include "fileutil.h"


CString CPWSServer::GetDocumentRoot()
{
	DWORD r;
    const int BUFSIZE = 256;
    static TCHAR buffer[BUFSIZE];

    r = GetPrivateProfileString(
                "FrontPage 2.0",
                _T("PWSRoot"),
                _T(""),
                buffer,
                BUFSIZE,
                "frontpg.ini");
    if (0 == r)
        buffer[0] = _T('\0');
    return (buffer);	
}

CString CPWSServer::GetCgiBinDir()
{
	// We're just assuming they haven't moved it rather than poke around
	// the .cnf files
	CString result = m_DocumentRoot + "\\Content\\cgi-bin";
	// But if it's not here, don't create it
	if (!IsDir(result))
		return "";
	else
		return result;	
}

CString CPWSServer::GetBotDir()
{
	return (m_DocumentRoot + "\\Content\\_vti_bot");
}



CString CMSPWSServer::GetDocumentRoot()
{
	return GetMSPWSVirtRoot("/");	
}


CString CMSPWSServer::GetCgiBinDir()
{
	return GetMSPWSVirtRoot("/cgi-bin");	
}

CString CMSPWSServer::GetBotDir()
{
	return (m_DocumentRoot + "\\_vti_bot");	
}

CString CMSPWSServer::GetMSPWSVirtRoot(CString dir)
{
	HKEY rootKey;
	// Open HKEY_LOCAL_MACHINE\System\CurrentControlSet\...
	long result = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Services\\W3SVC\\Parameters\\Virtual Roots",
					0, KEY_QUERY_VALUE, &rootKey);

	if (result != ERROR_SUCCESS)
		return "";


	DWORD Type;
	BYTE Data[MAX_PATH];
	DWORD chData = MAX_PATH;
	
    // Try finding MS PWS value
	result = RegQueryValueEx(rootKey, dir, NULL, &Type, Data, &chData);
    if (result != ERROR_SUCCESS)
        // Try finding MS IIS value
        result = RegQueryValueEx(rootKey, dir + ",", NULL, &Type, Data, &chData);

	if (result == ERROR_SUCCESS && Type == REG_SZ)
	{
		// We got a value.  It's in the form path,username,access.
		// So just return up to the first comma.
		for (UINT i=0; i < chData; i++)
		{
			if (Data[i] == ',')
			{
				Data[i] = '\0';
				break;
			}
		}
		return CString(Data);
	}
	else
		return "";

}
