//
// Copyright (c) 1996 Vermeer Technologies, Inc., a wholly owned
//               subsidiary of Microsoft Corp.  All Rights Reserved

//////////////////////////////////////////////////////
// CServer.cpp
//
// Defines CServer base class

#include <stdafx.h>
#include "server.h"
#include "resource.h"
#include "fileutil.h"


CServer::CServer()
{
	m_bInstallable = FALSE;
}


BOOL CServer::IsInstallable()
{	
    // This program always installs the bots in the _vti_bot directory of the
    // web server's root directory.  (For a multi-hosted MS IIS server, this
    // means only the default root.)

    // Another way to install the bot would be to install it in the bots
    // directory in the FrontPage install directory.  See the FrontPage
    // SDK documentation for more details.

	m_DocumentRoot = GetDocumentRoot();
	m_CgiBinDir = GetCgiBinDir();
	m_BotDir = GetBotDir();

	if (m_DocumentRoot.IsEmpty() || m_CgiBinDir.IsEmpty() || m_BotDir.IsEmpty())
		m_bInstallable = FALSE;
	else
		m_bInstallable = TRUE;

	return m_bInstallable;
}


BOOL CServer::Install()
{
	if (!m_bInstallable)
		return FALSE;

	if (!MyCreateDir(m_CgiBinDir))		
		return FALSE;

	if (!MyCreateDir(m_BotDir))
		return FALSE;
	
	CString specificBotDir = m_BotDir + "\\fpcount";

	if (!MyCreateDir(specificBotDir))
		return FALSE;

	if (!MyCopyFile("fpcount.inf", specificBotDir))
		return FALSE;
	if (!MyCopyFile("fpcntsrv.dll", specificBotDir))
		return FALSE;
	if (!MyCopyFile("fpcntclt.dll", specificBotDir))
		return FALSE;
	if (!MyCopyFile("fpcntclt.btl", specificBotDir))
		return FALSE;
	if (!MyCopyFile("fpcount.exe", m_CgiBinDir))
		return FALSE;

	return TRUE;
}
